<?php
/*
Plugin Name: 微博热搜榜
Plugin URI: https://liuronghuan.com
Description: 微博热搜最新10条，一键直达！
Author: Meediy
Author URI: https://liuronghuan.com
Version: 1.0
*/
header("Content-type: text/json; charset=utf-8");
//取文本中间
function getSubstr($str, $leftStr, $rightStr)
{
    $left = strpos($str, $leftStr);
    //echo '左边:'.$left;
    $right = strpos($str, $rightStr,$left);
    //echo '<br>右边:'.$right;
    if($left < 0 or $right < $left) return '';
    return substr($str, $left + strlen($leftStr), $right-$left-strlen($leftStr));
}
//curl封装
function http_get($url){
    $oCurl = curl_init();
    if(stripos($url,"https://")!==FALSE){
        curl_setopt($oCurl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($oCurl, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($oCurl, CURLOPT_SSLVERSION, 1); //CURL_SSLVERSION_TLSv1
    }
    curl_setopt($oCurl, CURLOPT_URL, $url);
    curl_setopt($oCurl, CURLOPT_RETURNTRANSFER, 1 );
    $sContent = curl_exec($oCurl);
    $aStatus = curl_getinfo($oCurl);
    curl_close($oCurl);
    if(intval($aStatus["http_code"])==200){
        return $sContent;
    }else{
        return false;
    }
}
function http_post($url,$param,$post_file=false){
    $oCurl = curl_init();
    if(stripos($url,"https://")!==FALSE){
        curl_setopt($oCurl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($oCurl, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($oCurl, CURLOPT_SSLVERSION, 1); //CURL_SSLVERSION_TLSv1
    }
    if (is_string($param) || $post_file) {
        $strPOST = $param;
    } else {
        $aPOST = array();
        foreach($param as $key=>$val){
            $aPOST[] = $key."=".urlencode($val);
        }
        $strPOST =  join("&", $aPOST);
    }
    curl_setopt($oCurl, CURLOPT_URL, $url);
    curl_setopt($oCurl, CURLOPT_RETURNTRANSFER, 1 );
    curl_setopt($oCurl, CURLOPT_POST,true);
    curl_setopt($oCurl, CURLOPT_POSTFIELDS,$strPOST);
    $sContent = curl_exec($oCurl);
    $aStatus = curl_getinfo($oCurl);
    curl_close($oCurl);
    if(intval($aStatus["http_code"])==200){
        return $sContent;
    }else{
        return false;
    }
}
function curl_get_https($url)
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_HEADER, false);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.11 (KHTML, like Gecko) Chrome/23.0.1271.1 Safari/537.11');
    $res = curl_exec($ch);
    $rescode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);
    return $res;
}
//添加小工具
function meediy_dashboard_weiboh(){
    echo '<p>欢迎使用<a href="https://liuronghuan.com" title="Meediy" target="_blank">Meediy</a> Weibo热搜榜小工具！！</p>';
    echo '<ul>';
    $data = http_get("https://s.weibo.com/top/summary?cate=realtimehot");
    $data = getSubstr($data, '<tbody>', '</tbody>');
    preg_match_all('/weibo\?q=(.*)&Refer/' , $data , $matches);
    for ($x=0; $x<=9; $x++) {
        $str = urldecode($matches[1][$x]);
        $str = str_replace("#","",$str);
        $str = str_replace("&topic_ad=1","",$str);
        $arr[] = $str;//数组输出
    }
    $i=1;
    foreach ($arr as $value) {
        echo '<li>'.$i.'、<a href="https://s.weibo.com/weibo?q='.$value.'" title="'.$value.'" target="_blank">'.$value.'</a></p></li>';
        $i++;
    }
    echo '</ul>';
}
function meediy_weiboh_register_widgets(){
    wp_add_dashboard_widget( 'our-css-id', '微博热搜榜', 'meediy_dashboard_weiboh');
}
add_action('wp_dashboard_setup', 'meediy_weiboh_register_widgets' );
?>